#-------------------------------------------------
#
# Project created by QtCreator 2018-03-07T02:18:16
#
#-------------------------------------------------

QT       += core gui

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = game
TEMPLATE = app
CONFIG += c++14

# The following define makes your compiler emit warnings if you use
# any feature of Qt which has been marked as deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if you use deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

INCLUDEPATH += $$PWD/include/

##create_res_folder.target = $$OUT_PWD/res
#QMAKE_EXTRA_TARGETS += createFolder
#createFolder.target = createResFolder
#createFolder.commands =

#POST_TARGETDEPS += createResFolder

#QMAKE_PRE_LINK = $(MKDIR) $$OUT_PWD/res/

# ================================================== #

win32 {
    build_pass: CONFIG(debug, debug|release) {
        DESTDIR = $$OUT_PWD/debug
    }
    else: build_pass {
        DESTDIR = $$OUT_PWD/release
    }
}

unix {
    DESTDIR = $$OUT_PWD
}

guiRes.target = BuildResources
exists($$DESTDIR/res) {
        message("Directory $$DESTDIR/res already exists")
    } else {
            guiRes.commands += $(MKDIR) \"$$DESTDIR/res\" $$escape_expand(\n\t)
    }

win32 {
    guiRes.commands += rcc.exe -binary $$PWD/res/hotseatgame/game_ui.qrc -o $$DESTDIR/res/gui_data.gtr $$escape_expand(\n\t) \
                       rcc.exe -binary $$PWD/res/hotseatgame/units.qrc -o $$DESTDIR/res/unit_data.gtr $$escape_expand(\n\t) \
                       rcc.exe -binary $$PWD/res/hotseatgame/effects.qrc -o $$DESTDIR/res/effect_data.gtr $$escape_expand(\n\t) \
                       rcc.exe -binary $$PWD/res/hotseatgame/spells.qrc -o $$DESTDIR/res/spell_data.gtr
}

unix {
    guiRes.commands += rcc -binary $$PWD/res/hotseatgame/game_ui.qrc.qrc -o $$DESTDIR/res/game_ui_data.gtr $$escape_expand(\n\t) \
                       rcc -binary $$PWD/res/hotseatgame/units.qrc -o $$DESTDIR/res/unit_data.gtr $$escape_expand(\n\t) \
                       rcc -binary $$PWD/res/hotseatgame/effects.qrc -o $$DESTDIR/res/effect_data.gtr $$escape_expand(\n\t) \
                       rcc -binary $$PWD/res/hotseatgame/spells.qrc -o $$DESTDIR/res/spell_data.gtr
}

QMAKE_EXTRA_TARGETS += guiRes
PRE_TARGETDEPS += BuildResources

# ================================================== #
SOURCES += \
    source/main.cpp \
    source/Cell.cpp \
    source/gui/Scene.cpp \
    source/gui/GuiSceneManager.cpp \
    source/gui/GUI.cpp \
    source/gui/MainMenu.cpp \
    source/gui/LoadingForm.cpp \
    source/units/Mage.cpp \
    source/units/Unit.cpp \
    source/units/Warrior.cpp \
    source/PlayerManager.cpp \
    source/Race.cpp \
    source/RaceManager.cpp \
    source/hotseatgame/GameManager.cpp \
    source/hotseatgame/UnitsQueue.cpp \
    source/hotseatgame/gui/PlayerVsPlayerIntro.cpp \
    source/hotseatgame/gui/PreBattleScene.cpp \
    source/hotseatgame/gui/RaceIcon.cpp \
    source/hotseatgame/gui/RecruitmentScene.cpp \
    source/hotseatgame/gui/UnitIcon.cpp \
    source/hotseatgame/gui/HotSeatGame.cpp \
    source/effects/Effect.cpp

HEADERS += \
    include/Cell.h \
    include/Player.h \
    include/PlayerManager.h \
    include/Race.h \
    include/RaceManager.h \
    include/AbstractFactory.h \
    include/units/Mage.h \
    include/units/Unit.h \
    include/units/Warrior.h \
    include/gui/GUI.h \
    include/gui/GuiSceneManager.h \
    include/gui/MainMenu.h \
    include/gui/Scene.h \
    include/gui/LoadingForm.h \
    include/hotseatgame/GameManager.h \
    include/hotseatgame/UnitsQueue.h \
    include/hotseatgame/gui/PlayerVsPlayerIntro.h \
    include/hotseatgame/gui/PreBattleScene.h \
    include/hotseatgame/gui/RaceIcon.h \
    include/hotseatgame/gui/RecruitmentScene.h \
    include/hotseatgame/gui/UnitIcon.h \
    include/hotseatgame/gui/HotSeatGame.h \
    include/effects/Effect.h

FORMS += \
    include/gui/GUI.ui \
    include/gui/MainMenu.ui \
    include/hotseatgame/gui/PlayerVsPlayerIntro.ui \
    include/hotseatgame/gui/PreBattleScene.ui \
    include/hotseatgame/gui/RecruitmentScene.ui \
    include/hotseatgame/gui/HotSeatGame.ui \
    include/gui/LoadingForm.ui

RESOURCES += \
     res/GUI.qrc
     #res/hotseatgame/game_ui.qrc \
     #res/hotseatgame/units.qrc \
     #res/hotseatgame/spells.qrc \
     #res/hotseatgame/effects.qrc

RC_ICONS = $$PWD/assets/common/icon.ico
